VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H8000000A&
   Caption         =   "Duffing Attractor"
   ClientHeight    =   6030
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7320
   LinkTopic       =   "Form1"
   ScaleHeight     =   402
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   488
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSalir 
      Caption         =   "Salir"
      Height          =   375
      Left            =   6120
      TabIndex        =   2
      Top             =   720
      Width           =   1095
   End
   Begin VB.CommandButton cmdEjecutar 
      Caption         =   "Ejecutar"
      Height          =   375
      Left            =   6120
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00000000&
      Height          =   6015
      Left            =   0
      ScaleHeight     =   397
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   397
      TabIndex        =   0
      Top             =   0
      Width           =   6015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const WavelengthMinimum = 380
Const WavelengthMaximum = 780
Const IntensityMax = 255
Const Gamma = 0.8


Const MaxPuntos = 10000
Const FactorDeEscala = 125
Const a = 0.25
Const B = 0.3
Const w = 1#

Dim RGBColor(0 To 255, 0 To 2) As Double

Dim ScreenX, ScreenY As Long

Function Power(ByVal x As Double, ByVal y As Double) As Double
If (x = 0#) Then
    If (y = 0#) Then
        Power = 1#
    Else
        Power = 0#
    End If
Else
    Power = Exp(Log(x) * y)
End If
End Function

Function Adjust(ByVal color As Double, ByVal factor As Double) As Double
If (color = 0#) Then
    Adjust = 0#
Else
    Adjust = IntensityMax * Power(color * factor, Gamma)
End If
End Function

Sub WavelengthToRGB(ByVal wavelength As Double, R As Double, G As Double, B As Double)
Dim Red, Green, Blue As Double
Dim factor As Double
Select Case Int(wavelength)
    Case 380 To 439
        Red = -(wavelength - 440) / (440 - 380)
        Green = 0#
        Blue = 1#
    Case 440 To 489
        Red = 0#
        Green = (wavelength - 440) / (490 - 440)
        Blue = 1#
    Case 490 To 509
        Red = 0#
        Green = 1#
        Blue = -(wavelength - 510) / (510 - 490)
    Case 510 To 579
        Red = (wavelength - 510) / (580 - 510)
        Green = 1#
        Blue = 0#
    Case 580 To 644
        Red = 1#
        Green = -(wavelength - 645) / (645 - 580)
        Blue = 0#
    Case 645 To 780
        Red = 1#
        Green = 0#
        Blue = 0#
    Case Else
        Red = 0#
        Green = 0#
        Blue = 0#
End Select
Select Case Int(wavelength)
    Case 380 To 419
        factor = 0.3 + 0.7 * (wavelength - 380) / (420 - 380)
    Case 420 To 700
        factor = 1#
    Case 701 To 780
        factor = 0.3 + 0.7 * (780 - wavelength) / (780 - 700)
    Case Else
        factor = 0#
End Select
R = Adjust(Red, factor)
G = Adjust(Green, factor)
B = Adjust(Blue, factor)
End Sub

Private Sub Rainbow()
Dim length As Double
Dim delta As Double
Dim i As Integer
Dim Red As Double
Dim Green As Double
Dim Blue As Double

delta = (WavelengthMaximum - WavelengthMinimum) / IntensityMax
length = WavelengthMinimum
For i = 0 To IntensityMax
    WavelengthToRGB length, Red, Green, Blue
    RGBColor(i, 0) = Red
    RGBColor(i, 1) = Green
    RGBColor(i, 2) = Blue
    length = length + delta
Next i
End Sub

Function dx(ByVal t As Double, ByVal x As Double, ByVal y As Double) As Double
dx = y
End Function

Function dy(ByVal t As Double, ByVal x As Double, ByVal y As Double) As Double
dy = x - x * x * x - a * y + B * Cos(w * t)
End Function

Sub Duffing()
Dim x, y, t As Double
Dim sx, sy As Double
Dim h As Double
Dim N, nPuntos As Long
Dim Red, Green, Blue As Double

Picture1.Cls
t = 0
x = 1#
y = 1#
nPuntos = 0
h = 0.05
Do While (nPuntos < MaxPuntos)
    x = x + h * dx(t, x, y)
    y = y + h * dy(t, x, y)
    t = t + h
    sx = FactorDeEscala * x + ScreenX / 2
    sy = FactorDeEscala * y + ScreenY / 2
    N = nPuntos Mod 255
    Red = RGBColor(N, 0)
    Green = RGBColor(N, 1)
    Blue = RGBColor(N, 2)
    Picture1.PSet (sx, ScreenY - sy), RGB(Red, Green, Blue)
    nPuntos = nPuntos + 1
Loop
End Sub

Private Sub cmdEjecutar_Click()
Call Duffing
End Sub

Private Sub cmdSalir_Click()
Unload Me
End Sub

Private Sub Form_Load()
Picture1.ScaleMode = 3
ScreenX = Picture1.ScaleWidth
ScreenY = Picture1.ScaleHeight
Rainbow
End Sub
